//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrLawnGreen
#property indicator_color4  clrOrangeRed
#property indicator_color5  clrOrangeRed
#property indicator_color6  clrSilver
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};
enum enAvgTypes
{
   ma_sma,  // Simple moving average (SMA)
   ma_ema,  // Exponential moving average (EMA)
   ma_smma, // Smoothed moving average (SMMA)
   ma_lwma, // Linear weighted moving average (LWMA)
   ma_oma   // One more average (OMA)
};

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                SZOPeriod       = 34;
extern double             OmaSpeed        = 1.0;
extern bool               OmaAdaptive     = false;
extern int                SZOLongPeriod   = 30;
extern enPrices           SZOPrice        = pr_hatbiased; // Price to use 
extern double             SZOPercent      = 95;
extern int                AveragePeriod   = 14;
extern enAvgTypes         AverageType     = ma_ema;
extern bool               ColorOnSlope    = false;
extern bool               alertsOn        = true;         // Turn alerts on
extern bool               alertsOnCurrent = false;        // Alerts on currnt (still opened) bar
extern bool               alertsMessage   = true;         // Alerts should show pop-up message
extern bool               alertsSound     = false;        // Alerts should play alert sound
extern bool               alertsPushNotif = false;        // Alerts should send push notification
extern bool               alertsEmail     = false;        // Alerts should send email
extern bool               Interpolate     = true;

//
//
//
//
//

double upz[];
double dnz[];
double szo[];
double szoDa[];
double szoDb[];
double avg[];
double prices[];
double colors[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,upz);
   SetIndexBuffer(1,dnz);
   SetIndexBuffer(2,szo);
   SetIndexBuffer(3,szoDa);
   SetIndexBuffer(4,szoDb);
   SetIndexBuffer(5,avg);
   SetIndexBuffer(6,prices);
   SetIndexBuffer(7,colors);
   
   OmaSpeed          = MathMax(OmaSpeed,-1.5);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" Sentiment zone oscillator ("+SZOPeriod+","+SZOLongPeriod+")");
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { upz[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     if (colors[limit]==-1) CleanPoint(limit,szoDa,szoDb);
     for(int i=limit; i>=0; i--)
     {
        prices[i] = getPrice(SZOPrice,Open,Close,High,Low,i);
           double useValue = 0;
              if (prices[i]>prices[i+1]) useValue =  1;
              if (prices[i]<prices[i+1]) useValue = -1;
           double result = 100.0*iOma(useValue,SZOPeriod,OmaSpeed,OmaAdaptive,i,0);  
      
           //
           //
           //
           //
           //
         
           szo[i] =  result/SZOPeriod;  
              double hi = szo[ArrayMaximum(szo,SZOLongPeriod,i)];
              double lo = szo[ArrayMinimum(szo,SZOLongPeriod,i)];
              double rn = hi-lo;
           upz[i] = lo+rn*SZOPercent/100.0;
           dnz[i] = hi-rn*SZOPercent/100.0;
   }       
   for(i=limit; i>=0; i--) 
   {
      if (AverageType==ma_oma)
            avg[i] = iOma(szo[i],AveragePeriod,OmaSpeed,OmaAdaptive,i,1);
      else  avg[i] = iMAOnArray(szo,0,AveragePeriod,0,(int)AverageType,i);
      szoDa[i]  = EMPTY_VALUE;
      szoDb[i]  = EMPTY_VALUE;
      colors[i]  = colors[i+1];
          if (ColorOnSlope)
          {
            if (szo[i]>szo[i+1]) colors[i] =  1;
            if (szo[i]<szo[i+1]) colors[i] = -1;
          }
          else
          {
            if (szo[i]>avg[i])   colors[i] =  1;
            if (szo[i]<avg[i])   colors[i] = -1;
          }
            if (colors[i]==-1) PlotPoint(i,szoDa,szoDb,szo);
   }
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
     
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (colors[limit]==-1) CleanPoint(limit,szoDa,szoDb);
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          upz[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,OmaSpeed,OmaAdaptive,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,ColorOnSlope,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,0,y);          
          dnz[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,OmaSpeed,OmaAdaptive,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,ColorOnSlope,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,1,y);  
          szo[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,OmaSpeed,OmaAdaptive,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,ColorOnSlope,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,2,y);
          szoDa[i]  = EMPTY_VALUE;
          szoDb[i]  = EMPTY_VALUE;  
          avg[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,OmaSpeed,OmaAdaptive,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,ColorOnSlope,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,5,y);              
          colors[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,OmaSpeed,OmaAdaptive,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,ColorOnSlope,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,7,y);
                                                   
          //
          //
          //
          //
          //
            
          if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,TimeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int k = 1; k < n; k++)
             {
  	             upz[i+k] = upz[i] + (upz[i+n] - upz[i]) * k/n;
  	             dnz[i+k] = dnz[i] + (dnz[i+n] - dnz[i]) * k/n;
  	             szo[i+k] = szo[i] + (szo[i+n] - szo[i]) * k/n;
  	             avg[i+k] = avg[i] + (avg[i+n] - avg[i]) * k/n;
            }
   }
   for (i=limit;i>=0; i--) if (colors[i]==-1) PlotPoint(i,szoDa,szoDb,szo);
return(0);
}



//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][14];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
return(v03);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      
      //
      //
      //
      //
      //
      
      
         if (colors[whichBar] != colors[whichBar+1])
         {
            if (colors[whichBar] == 1) doAlert(whichBar,"up");
            if (colors[whichBar] ==-1) doAlert(whichBar,"down");
         }                
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SZO ",doWhat);
             if (alertsMessage)   Alert(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol(),"SZO"),message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
} 

